@Echo off
SETLOCAL EnableDelayedExpansion
MODE CON COLS=90 LINES=36
TITLE Update7 Integrator
CD /D "%~dp0"


:: SET CreationDateWIM=DD.MM.YYYY
:: SET CreationTimeWIM=HH:MM:SS

:: SET "TimeStampFilesISO32bit=-T04/11/2011,23:27:40 -G-7"
:: SET "TimeStampFilesISO64bit=-T04/12/2011,07:45:21 -G-7"


FOR /F "Tokens=2,3 Delims=[.]" %%A IN ('VER') DO SET OSVer=%%A%%B
IF %OSVer:~-3% LSS 61 (
  MODE CON COLS=75 LINES=12
  ECHO. & ECHO For work of integrator needs Windows 7 or later.
  ECHO. & PAUSE & EXIT
)
FOR %%I IN (7z.exe 7z.dll CDIMAGE_2.54m.exe ConvertDateHex.exe efisys.bin etfsboot.bin libwim-15.dll wimlib-imagex.exe) DO IF NOT EXIST BIN\%%I (
  MODE CON COLS=75 LINES=12
  ECHO. & ECHO For work of integrator in directory "BIN" missing necessary component.
  ECHO. & PAUSE & EXIT
)
IF NOT EXIST "IMAGE\*.iso" IF NOT EXIST IMAGE\install.wim (
  MODE CON COLS=75 LINES=12
  ECHO. & ECHO In the catalog "IMAGE" not found image file ^(*.iso or install.wim^) OS.
  ECHO. & PAUSE & EXIT
)
IF NOT EXIST UpdatePack7R2\UpdatePack7R2-*.exe (
  MODE CON COLS=75 LINES=12
  ECHO. & ECHO In directory "UpdatePack7R2" not found "UpdatePack7R2-XX.XX.XX.exe".
  ECHO. & PAUSE & EXIT
)


ECHO %* | FINDSTR /IRC:"\</Optimize=esd\>" >nul && SET "OptimizeInstallWim=esd"
FOR %%I IN (%*) DO (
  IF /I "%%I"=="/NoUSB" SET "ParamStr=/NoUSB"
  IF /I "%%I"=="/NVMe" SET "ParamStr=!ParamStr! /NVMe"
  IF /I "%%I"=="/SmartFix" SET "ParamStr=!ParamStr! /SmartFix"
  IF /I "%%I"=="/FixOn"  ECHO %* | FIND /I "/FixOff " >nul || SET "ParamStr=!ParamStr! /FixOn"
  IF /I "%%I"=="/FixOff" ECHO %* | FIND /I "/FixOn "  >nul || SET "ParamStr=!ParamStr! /FixOff"
  IF /I "!Previous!"=="/Temp" IF EXIST %%I SET "ParamStrTemp=/NoSpace /Temp=%%~I"
  SET Previous=%%I
)


FOR /F "Tokens=1,2 Delims=-" %%I IN ('DIR /A-D /B UpdatePack7R2\UpdatePack7R2-*.exe') DO SET "UpdatePackEXE=%%I-%%J" & SET "UPVer=%%~nJ"


IF EXIST "IMAGE\*.iso" (
  FOR %%I IN ("IMAGE\*.iso") DO (
    BIN\7z.exe X "IMAGE\%%~nI.iso" -O"IMAGE\%%~nI" -AOs -Y
    SET "WIMDir=IMAGE\%%~nI\sources"
    SET "ISOName=%%~nI"
    CALL:ChoiceEditionMenu
    CALL:IntegrateUP
    IF NOT "%OptimizeInstallWim%"=="esd" (
      CALL:GetInfoBootWim
      CALL:IntegrateDrvToBootWim
      CALL:IntegrateDrvFiraDisk
      CALL:YeSNoCreateISOMenu
    )
    CLS
  )
)


IF EXIST IMAGE\install.wim (
  SET WIMDir=IMAGE
  SET ISOName=
  CALL:ChoiceEditionMenu
  CALL:IntegrateUP
  CALL:GetInfoBootWim
  CALL:IntegrateDrvToBootWim
  CALL:IntegrateDrvFiraDisk
)


CLS & ECHO. & ECHO Done. & ECHO. & PAUSE & EXIT


:ChoiceEditionMenu
 CLS
 SET GtrCntLin=0
 SET TotCntLin=0
 ECHO. & ECHO You must specify the index number edition OS, which will be integrated update.
 FOR /F "Tokens=1* Delims=:" %%A IN ('BIN\wimlib-imagex.exe info "%WIMDir%\install.wim" ^| FINDSTR /N "^$ ^Index: ^Name: Creation.Time: Architecture: Languages:"') DO SET "Sort=000%%A" & SET "Lines!Sort:~-5!=%%B "
 FOR /F "Tokens=2" %%A IN ('SET Lines ^| FIND "Index:"') DO SET TotCntIndex=%%A
 FOR /F %%A IN ('SET Lines') DO SET /A TotCntLin+=1
 IF %TotCntLin% LEQ 31 (
   FOR /F "Tokens=1* Delims==" %%A IN ('SET Lines') DO @ECHO.%%B
 )
 IF %TotCntLin% GTR 31 (
   FOR /F "Tokens=1* Delims==" %%A IN ('SET Lines') DO (
     SET /A GtrCntLin+=1
     @ECHO.%%B
     IF !GtrCntLin! GTR 29 (SET "GtrCntLin=0" & ECHO. & PAUSE & CLS)
   )
 )
 ECHO.
 REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 SET SILENT=
 SET CHOICE=
 SET ChoiceErr=
 SET IndexEdition=
 FOR /F "Tokens=2,3 Delims=[-]" %%A IN ("%ISOName%") DO (
   ECHO %%A| >nul FINDSTR /IX "index" && (ECHO %%B| >nul FINDSTR /RC:"[^0-9,]" /RC:"^0[0-9]" /C:"^0," /C:",0" || SET CHOICE=%%B)
 )
 IF DEFINED CHOICE (
   IF "%CHOICE%"=="0" SET "IndexEdition=*" & SET "SILENT=Yes" & GOTO:EOF
   FOR %%I IN (%CHOICE%) DO IF %%I GTR %TotCntIndex% SET ChoiceErr=1
   IF NOT "!ChoiceErr!"=="1" FOR %%I IN (!CHOICE!) DO (
     IF NOT DEFINED X%%I IF NOT DEFINED IndexEdition (SET "IndexEdition=%%I") ELSE (SET "IndexEdition=!IndexEdition! %%I")
     SET X%%I=*
   )
   IF NOT "!ChoiceErr!"=="1" FOR /F "Tokens=1 Delims==" %%I IN ('SET X') DO SET %%I=
 )
 IF DEFINED IndexEdition SET "SILENT=Yes" & GOTO:EOF
 REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 SET /P CHOICE="Enter index numbers separated by commas or "*" for all images => "
 SET "CHOICE=%CHOICE:,= %"
 IF "%CHOICE%"=="*" SET "IndexEdition=*" & GOTO:EOF
 ECHO %CHOICE% | >nul FINDSTR /RC:"[^0-9 ]" /RC:"^0[0-9]" /C:"^0 " /C:" 0" && GOTO:ChoiceEditionMenu
 FOR %%I IN (%CHOICE%) DO (
   IF %%I GTR %TotCntIndex% GOTO:ChoiceEditionMenu
   IF NOT DEFINED X%%I IF NOT DEFINED IndexEdition (SET IndexEdition=%%I) ELSE (SET IndexEdition=!IndexEdition! %%I)
   SET X%%I=*
 )
 FOR /F "Tokens=1 Delims==" %%I IN ('SET X') DO SET %%I=
GOTO:EOF


:IntegrateUP
 REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 DIR /A-D /B /S "DRIVERS\InstallWim\*.INF" >nul 2>&1 && (
   IF "%ParamStrTemp%"=="" (SET UPTempDir=%WinDir%\Temp\UpdatePack7Wim) ELSE (SET UPTempDir=%ParamStrTemp:~15%)
   IF EXIST UpdatePack7R2Wim.cmd (REN UpdatePack7R2Wim.cmd UpdatePack7R2Wim_2.cmd 2>nul) ELSE (SET UpdatePack7R2WimCmd=Del)
   >UpdatePack7R2Wim.cmd ECHO @Echo off
   >>UpdatePack7R2Wim.cmd ECHO IF EXIST "!UPTempDir!\Windows\SysWOW64\cabinet.dll" (SET BIT=x64^) ELSE (SET BIT=x86^)
   >>UpdatePack7R2Wim.cmd ECHO DISM /Image:"!UPTempDir!" /Add-Driver /Driver:"%%~dp0DRIVERS\InstallWim\%%BIT%%" /Recurse /ForceUnsigned
   IF EXIST UpdatePack7R2Wim_2.cmd >>UpdatePack7R2Wim.cmd ECHO "%%~dp0UpdatePack7R2Wim_2.cmd"
 )
 REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 CLS & ECHO. & ECHO Process of integrate updates...
 IF NOT DEFINED CreationDateWIM (FOR /F "Tokens=1-3 Delims=." %%A IN ("%UPVer%") DO SET CreationDateWIM=%%C.%%B.20%%A)
 IF "%IndexEdition%"=="*" (
   UpdatePack7R2\%UpdatePackEXE% %ParamStr% %ParamStrTemp% /IE11 /WimFile=%~dp0%WIMDir%\install.wim /Index=*
   FOR /L %%I IN (1,1,%TotCntIndex%) DO (
     FOR /F "Tokens=1,2 Delims=- Skip=1" %%I IN ('BIN\ConvertDateHex.exe /D %CreationDateWIM% /T %CreationTimeWIM%') DO SET "HIGHPART=%%I" & SET "LOWPART=%%J"
     BIN\wimlib-imagex.exe info "%WIMDir%\install.wim" %%I --image-property CREATIONTIME/HIGHPART=!HIGHPART! --image-property CREATIONTIME/LOWPART=!LOWPART! >nul
     BIN\wimlib-imagex.exe info "%WIMDir%\install.wim" %%I --image-property LASTMODIFICATIONTIME/HIGHPART=!HIGHPART! --image-property LASTMODIFICATIONTIME/LOWPART=!LOWPART! >nul
   )
   DISM /Cleanup-Wim >nul
 ) ELSE (
   FOR %%I IN (%IndexEdition%) DO (
     UpdatePack7R2\%UpdatePackEXE% %ParamStr% %ParamStrTemp% /IE11 /WimFile=%~dp0%WIMDir%\install.wim /Index=%%I
     FOR /F "Tokens=1,2 Delims=- Skip=1" %%I IN ('BIN\ConvertDateHex.exe /D %CreationDateWIM% /T %CreationTimeWIM%') DO SET "HIGHPART=%%I" & SET "LOWPART=%%J"
     BIN\wimlib-imagex.exe info "%WIMDir%\install.wim" %%I --image-property CREATIONTIME/HIGHPART=!HIGHPART! --image-property CREATIONTIME/LOWPART=!LOWPART! >nul
     BIN\wimlib-imagex.exe info "%WIMDir%\install.wim" %%I --image-property LASTMODIFICATIONTIME/HIGHPART=!HIGHPART! --image-property LASTMODIFICATIONTIME/LOWPART=!LOWPART! >nul
     DISM /Cleanup-Wim >nul
   )
 )
 REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 IF "%UpdatePack7R2WimCmd%"=="Del" DEL /Q UpdatePack7R2Wim.cmd 2>nul
 IF EXIST UpdatePack7R2Wim_2.cmd DEL /Q UpdatePack7R2Wim.cmd 2>nul & REN UpdatePack7R2Wim_2.cmd UpdatePack7R2Wim.cmd 2>nul
 REM ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 CALL:OptimizationWim "install.wim"
GOTO:EOF


:GetInfoBootWim
 IF NOT EXIST "%WIMDir%\boot.wim" GOTO:EOF
 FOR /F "Tokens=1-3 Delims=: " %%I IN ('BIN\wimlib-imagex.exe info "%WIMDir%\boot.wim"') DO IF "%%I %%J"=="Boot Index" SET IndexBoot=%%K
 SET BitBoot=x86
 FOR /F "Tokens=2 Delims=: " %%I IN ('BIN\wimlib-imagex.exe info "%WIMDir%\boot.wim" %IndexBoot%') DO IF "%%I"=="x86_64" SET BitBoot=x64
GOTO:EOF


:IntegrateDrvToBootWim
 CLS
 IF NOT EXIST "%WIMDir%\boot.wim" GOTO:EOF
 DIR /A-D /B /S "DRIVERS\BootWim\%BitBoot%\*.INF" >nul 2>&1 || GOTO:EOF
 ECHO. & ECHO Integrate drivers to boot.wim...
 MD MOUNT 2>nul
 DISM /Mount-Wim /WimFile:"%WIMDir%\boot.wim" /Index:%IndexBoot% /MountDir:MOUNT
 DISM /Image:MOUNT /Add-Driver /Driver:DRIVERS\BootWim\%BitBoot% /Recurse /ForceUnsigned
 IF NOT "%SILENT%"=="Yes" ECHO. & PAUSE
 CLS
 DISM /Unmount-Wim /MountDir:MOUNT /Commit
 DISM /Cleanup-Wim >nul
 RD /S /Q MOUNT 2>nul
 IF NOT EXIST DRIVERS\BootWim\FiraDiskDrvInstall.cmd CALL:OptimizationWim "boot.wim"
GOTO:EOF


:IntegrateDrvFiraDisk
 CLS
 IF NOT EXIST "%WIMDir%\boot.wim" GOTO:EOF
 IF NOT EXIST DRIVERS\BootWim\FiraDiskDrvInstall.cmd GOTO:EOF
 ECHO. & ECHO Integrate FiraDisk driver...
 BIN\wimlib-imagex.exe extract "%WIMDir%\boot.wim" %IndexBoot% \Windows\System32\config\SYSTEM --no-attributes --dest-dir=DRIVERS >nul
 REG LOAD HKU\Mount_System DRIVERS\SYSTEM >nul
 REG ADD HKU\Mount_System\Setup /F /V CmdLine /D "CMD /Q /C START /B FiraDiskDrvInstall.cmd /INSTALL & winpeshl.exe" >nul
 REG UNLOAD HKU\Mount_System >nul
 BIN\wimlib-imagex.exe update "%WIMDir%\boot.wim" %IndexBoot% --command="add 'DRIVERS\BootWim\FiraDiskDrvInstall.cmd' '\Windows\System32\FiraDiskDrvInstall.cmd'" >nul
 BIN\wimlib-imagex.exe update "%WIMDir%\boot.wim" %IndexBoot% --command="add 'DRIVERS\SYSTEM' '\Windows\System32\config\SYSTEM'" >nul
 DEL /Q DRIVERS\SYSTEM 2>nul & DEL /Q /AH DRIVERS\* 2>nul
 CALL:OptimizationWim "boot.wim"
GOTO:EOF


:OptimizationWim
 CLS
 IF "%OptimizeInstallWim%"=="esd" (
   ECHO. & ECHO Export install.wim -^> install.esd... & ECHO.
   BIN\wimlib-imagex.exe export "%WIMDir%\install.wim" all "%WIMDir%\install.esd" --compress=LZMS:100 --solid
 ) ELSE (
   ECHO. & ECHO Optimization %~1... & ECHO.
   BIN\wimlib-imagex.exe optimize "%WIMDir%\%~1" --compress=LZX:100 --chunk-size=32768
 )
GOTO:EOF


:YeSNoCreateISOMenu
 CLS
 IF "%SILENT%"=="Yes" GOTO:GetInfoISO
 ECHO. & ECHO Integrate updates completed.
 ECHO. & ECHO Create image ^(ISO^)? & ECHO.
 SET YesNo=
 SET /P YesNo="Y=yes / N=no => "
 IF /I "%YesNo%"=="Y" GOTO:GetInfoISO
 IF /I "%YesNo%"=="N" GOTO:EOF
GOTO:YeSNoCreateISOMenu


:GetInfoISO
 CLS
 SET LABEL=
 FOR /F "Tokens=1,2 Delims=:= " %%I IN ('BIN\7z.exe L "IMAGE\%ISOName%.iso" -X^^^!*') DO (
   IF "%%I"=="Volume" SET LABEL=%%J
   IF "%%I"=="Comment" SET LABEL=%%J
 )
 IF NOT DEFINED LABEL (
   ECHO. & ECHO Specify a name the volume label ^(disk name^). & ECHO.
   SET /P LABEL="Enter your preferred name => "
   IF NOT DEFINED LABEL GOTO:GetInfoISO
   CLS
 )
 IF "%BitBoot%"=="x86" GOTO:CreateISOx86
 IF "%BitBoot%"=="x64" GOTO:CreateISOx64
 :ChoiceBitMenu
  CLS & ECHO.
  ECHO What bit operating system for which creating image:
  ECHO.
  ECHO   1. 32-bit ^(x86^)
  ECHO   2. 64-bit ^(x64^)
  ECHO.
  SET CHOICE=
  SET /P CHOICE="Make a choice [enter 1 or 2] => "
  IF /I "%CHOICE%"=="1" GOTO:CreateISOx86
  IF /I "%CHOICE%"=="2" GOTO:CreateISOx64
 GOTO:ChoiceBitMenu
GOTO:EOF


:CreateISOx86
 CLS
 BIN\CDIMAGE_2.54m.exe -L"%LABEL%" -U2 -UDFVER102 %TimeStampFilesISO32bit% -H -M -OC -BBIN\etfsboot.bin "%~dp0IMAGE\%ISOName%" "%ISOName%_v%UPVer%.iso"
GOTO:EOF


:CreateISOx64
 CLS
 BIN\CDIMAGE_2.54m.exe -L"%LABEL%" -U2 -UDFVER102 %TimeStampFilesISO64bit% -H -M -OC -BOOTDATA:2#p00,e,bBIN\etfsboot.bin#pEF,e,bBIN\efisys.bin "%~dp0IMAGE\%ISOName%" "%ISOName%_v%UPVer%.iso"
GOTO:EOF
